<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

class plgUserPap4 extends JPlugin {

  function plgUserPap4(& $subject, $config) {
    parent::__construct($subject, $config);
  }

  function onUserAfterSave($user, $isnew, $succes, $msg) {
    global $mainframe;

    // convert the user parameters to a format for the external application
    $args = array();
    $pos = strpos($user['name']," ");
    if ($pos !== false) {
      $args['fname'] = substr($user['name'],0,$pos-1);
      $args['lname'] = substr($user['name'],$pos+1);
    }
    else {
      $args['fname'] = "Joomla";
      $args['lname'] = $user['name'];
    }

    $args['email'] = $user['email'];
    $args['refid'] = $user['username'];
    $args['password'] = $user['password_clear'];

    if ($isnew) {
      jimport('joomla.html.parameter');
      require("PapApi.class.php");

      // load plugin params info
      $plugin =& JPluginHelper::getPlugin('user', 'pap4');
      $pluginParams = new JParameter( $plugin->params );

      $pap4Url = $pluginParams->get('pap4_url', 1);
      $pap4Username = $pluginParams->get('pap4_username', 1);
      $pap4Pwd = $pluginParams->get('pap4_password', 1);
      
      try {
        // login to API
        $session = new Gpf_Api_Session($pap4Url);
        if (!$session->login($pap4Username, $pap4Pwd)) {
            die("Please contact affiliate manager. Error message: ".$session->getMessage());
        }

        //identify the referrer (affiliate)
        $clickTracker = new Pap_Api_ClickTracker($session);
        try {
		  $clickTracker->track();
		  $clickTracker->saveCookies();
          
          $affiliate = $clickTracker->getAffiliate();
          $referralid = '';

          //if cookies were found - so an affiliate was recongized as a referrer
          if ($affiliate !== null) {
            $referralid = @$affiliate->getParam('refid'); //get the referral id of the referring affiliate
          }
        }
        catch (Exception $e) {
          //echo("No parent affiliate recognized: ".$e->getMessage());
        }

        // create new affiliate
        $affiliate = new Pap_Api_Affiliate($session);
        $affiliate->setUsername($args['email']);
        $affiliate->setPassword($args['password']);
        $affiliate->setFirstname($args['fname']);
        $affiliate->setLastname($args['lname']);
        $affiliate->setRefid($args['refid']);
        if ($referralid != '') { $affiliate->setParentUserId($referralid); }
        if(!$affiliate->add()) {
          die("Cannot add record, please contact affiliate manager. Error message: ".$affiliate->getMessage());
        }
        else {
          //echo("Affiliate successfully added");
        }
      }
      catch(Exception $e) {
        die("PAP4 API call error, please contact affiliate manager. Error message: ".$e->getMessage());
      }
    }
  }
}
